Com.Frog.Utils.require(
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/assets/styles/main.css',
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/assets/views/main.ejs',
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/assets/views/markbook.ejs',
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/assets/views/modal_body.ejs',
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/assets/views/row.ejs',
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/assets/views/select.ejs',
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/assets/views/tag.ejs',
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/assets/views/tags.ejs',
    '//package/widgets/0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D/widget.ejs'
).then(function() {
    Com.Frog.Controllers.Widget.extend('Widget.AssignmentsEngagement', {
    }, {
        prefs: {},

        markbook_data: null,
        collated_data: null,
        user_data: {},

        packageID: '0EB62D3F2001B1EC1AA79F98DF136A0FC39DA43CF271E66D',
        /**
         * Constructor. Runs when the widget is first loaded.
         *
         * @method init
         */
        init: function() {},

        /**
         * Event fired by the Site Controller.
         *
         * @event 'widget.live'
         */
        'widget.live': function(el, ev, data) {
            this.element.html(
                this.view('main.ejs')
            );

            this.render();
        },

        render: function() {
            var request_data = {
                url: 'academicyear/get',
                path: '../api/fdp/1/',
                dataType: 'json years',
                converters: {
                    'json years': function(data) {
                        return data.response;
                    }.bind(this)
                },
                data: {
                    'end_after' : moment().unix()
                }
            }

            Frog.Model.fdpapi(request_data).done(function(years){
                Frog.Model.fdpapi(request_data).done(function(response) {
                    var mb_params = {
                        'academic_year_uuid': years[0].uuid
                    };
                    Frog.Model.api('markbookmanager.getMarkbooks', mb_params).done(function(markbooks) {
                        this.renderMarkbooks(markbooks);
                    }.bind(this));
                }.bind(this));
            }.bind(this));
        },

        renderMarkbooks: function(markbooks) {
            this.markbook_data = markbooks.data;

            var tag_div = this.element.find('.tag-selector');

            tag_div.html(
                this.view('tags.ejs', {tags: this.markbook_data.tags})
            );
        },

        '.tags change' : function(el, ev) {
            var selected_tag = ev.target.value;
            var markbooks_div = this.element.find('.markbooks');
            markbooks_div.empty();

            if (selected_tag === "x") {
                markbooks_div.html(
                    this.view('select.ejs')
                );

                return;
            }

            var markbook_keys = Object.keys(this.markbook_data.tags[selected_tag].markbooks);

            var params = {
                name: this.markbook_data.tags[selected_tag].name,
                uuid: this.markbook_data.tags[selected_tag].uuid
            };

            markbooks_div.append(
                this.view('tag.ejs', params)
            );

            var markbook_holder = this.element.find('.tag-markbooks');
            for (var k = 0; k < markbook_keys.length; k++) {
                var mb = this.markbook_data.tags[selected_tag].markbooks[markbook_keys[k]];

                var markbook_params = {
                    subject: this.markbook_data.subjects[mb.subject_uuid].name,
                    group: this.markbook_data.groups[mb.group_uuid].name,
                    uuid: mb.uuid
                };

                markbook_holder.append(
                    this.view('markbook.ejs', markbook_params)
                );
            }
        },

        '.markbook click': function(el, ev) {
            var markbook_uuid = $(el.context).attr('data-uuid');
            var markbook_table = this.element.find('.markbook-table');
            var markbook_table_body = this.element.find('.markbook-table-body');
            var collated_data = {};

            markbook_table_body.empty();

            Frog.Model.api('markbookmanager.getmarkbookdata', {uuid: markbook_uuid}).done(function(response){
                var data_row_keys = Object.keys(response.data.row_data);
                for (var i = 0; i < data_row_keys.length; i++) {
                    var row = response.data.row_data[data_row_keys[i]];
                    var assignment_keys = Object.keys(row.assignments);
                    for (j = 0; j < assignment_keys.length; j++) {
                        if (!collated_data.hasOwnProperty(assignment_keys[j])) {
                            collated_data[assignment_keys[j]] = {
                                viewed:[],
                                unviewed:[]
                            }
                        }

                        if (row.assignments[assignment_keys[j]].viewed === "0") {
                            collated_data[assignment_keys[j]].unviewed.push(row.user.uuid);
                        } else {
                            collated_data[assignment_keys[j]].viewed.push(row.user.uuid);
                        }

                        this.user_data[row.user.uuid] = row.user.displayname;
                    }
                }

                this.collated_data = collated_data;

                var collated_keys = Object.keys(collated_data);
                for (var l = 0; l < collated_keys.length; l++) {
                    var row_params = {
                        assignment_name: response.data.assignments[collated_keys[l]].name,
                        viewed: collated_data[collated_keys[l]].viewed.length,
                        unviewed: collated_data[collated_keys[l]].unviewed.length,
                        uuid: collated_keys[l]
                    };

                    markbook_table.append(
                        this.view('row.ejs', row_params)
                    );
                }
            }.bind(this));
        },

        '.more-details click': function(el, ev) {
            var details = {
                viewed:[],
                unviewed: []
            };
            var assignment_uuid = el.context.getAttribute('data-uuid');

            for(var i = 0; i < this.collated_data[assignment_uuid].unviewed.length; i++) {
                details.unviewed.push(this.user_data[this.collated_data[assignment_uuid].unviewed[i]]);
            }

            for(var i = 0; i < this.collated_data[assignment_uuid].viewed.length; i++) {
                details.viewed.push(this.user_data[this.collated_data[assignment_uuid].viewed[i]]);
            }

            var details_modal = this.modal("Details", this.view('modal_body.ejs', details), 'details-modal');
        },

        /**
         * Event fired by the Site Controller. Tells the widget that the site is in Edit Mode.
         *
         * @event 'widget.edit'
         */
        'widget.edit': function(el, ev, data) {
            this.element.html(
                this.view('./widget.ejs')
            );
        },

        /**
         * Event fired by the Site Controller. Tells the widget that something has been changed during editing.
         *
         * @event 'widget.updated'
         */
        'widget.updated': function(el, ev, data) {}
    });
});
